/*
 * main.cpp
 *
 *  Created on: 18 окт. 2021 г.
 *      Author: alexander
 */

#include "fly_behavior.hpp"
#include "quack_behavior.hpp"
#include "duck.hpp"

int main()
{
    Duck *mallard = new MallardDuck;
    mallard->performQuack();
    mallard->performFly();

    Duck *model = new ModelDuck;
    model->performFly();
    model->setFlyBehavior(new FlyRocketPowered);
    model->performFly();

    delete mallard;
    delete model;

    return 0;
}
