/*
 * quack_behavior.hpp
 *
 *  Created on: 18 окт. 2021 г.
 *      Author: alexander
 */

#pragma once

#include <iostream>

class QuackBehavior
{
public:
    virtual void quack() = 0;
    virtual ~QuackBehavior() { }
};

class Quack : public QuackBehavior
{
public:
    void quack()
    {
        std::cout << "Quack" << std::endl;
    }
};

class Squeak : public QuackBehavior
{
public:
    void quack()
    {
        std::cout << "Squeak" << std::endl;
    }
};

class MuteQuack : public QuackBehavior
{
public:
    void quack()
    {
        std::cout << "<< Silence >>" << std::endl;
    }
};
